require 'rails_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to specify the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator.  If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails.  There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.
#
# Compared to earlier versions of this generator, there is very limited use of
# stubs and message expectations in this spec.  Stubs are only used when there
# is no simpler way to get a handle on the object needed for the example.
# Message expectations are only used when there is no simpler way to specify
# that an instance is receiving a specific message.

RSpec.describe TopicsController, type: :controller do
  # This should return the minimal set of attributes required to create a valid
  # Topic. As you add validations to Topic, be sure to
  # adjust the attributes here as well.
  let(:valid_attributes) do
    skip('Add a hash of attributes valid for your model')
  end

  let(:invalid_attributes) do
    skip('Add a hash of attributes invalid for your model')
  end

  # This should return the minimal set of values that should be in the session
  # in order to pass any filters (e.g. authentication) defined in
  # TopicsController. Be sure to keep this updated too.
  let(:valid_session) { {} }

  describe 'GET #index' do
    it 'assigns all topics as @topics' do
      topic = Topic.create! valid_attributes
      get :index, {}, valid_session
      expect(assigns(:topics)).to eq([topic])
    end
  end

  describe 'GET #show' do
    it 'assigns the requested topic as @topic' do
      topic = Topic.create! valid_attributes
      get :show, { id: topic.to_param }, valid_session
      expect(assigns(:topic)).to eq(topic)
    end
  end

  describe 'GET #edit' do
    it 'assigns the requested topic as @topic' do
      topic = Topic.create! valid_attributes
      get :edit, { id: topic.to_param }, valid_session
      expect(assigns(:topic)).to eq(topic)
    end
  end

  describe 'POST #create' do
    context 'with valid params' do
      it 'creates a new Topic' do
        expect do
          post :create, { topic: valid_attributes }, valid_session
        end.to change(Topic, :count).by(1)
      end

      it 'assigns a newly created topic as @topic' do
        post :create, { topic: valid_attributes }, valid_session
        expect(assigns(:topic)).to be_a(Topic)
        expect(assigns(:topic)).to be_persisted
      end

      it 'redirects to the created topic' do
        post :create, { topic: valid_attributes }, valid_session
        expect(response).to redirect_to(Topic.last)
      end
    end

    context 'with invalid params' do
      it 'assigns a newly created but unsaved topic as @topic' do
        post :create, { topic: invalid_attributes }, valid_session
        expect(assigns(:topic)).to be_a_new(Topic)
      end

      it "re-renders the 'new' template" do
        post :create, { topic: invalid_attributes }, valid_session
        expect(response).to render_template('new')
      end
    end
  end

  describe 'PUT #update' do
    context 'with valid params' do
      let(:new_attributes) do
        skip('Add a hash of attributes valid for your model')
      end

      it 'updates the requested topic' do
        topic = Topic.create! valid_attributes
        put :update, { id: topic.to_param, topic: new_attributes }, valid_session
        topic.reload
        skip('Add assertions for updated state')
      end

      it 'assigns the requested topic as @topic' do
        topic = Topic.create! valid_attributes
        put :update, { id: topic.to_param, topic: valid_attributes }, valid_session
        expect(assigns(:topic)).to eq(topic)
      end

      it 'redirects to the topic' do
        topic = Topic.create! valid_attributes
        put :update, { id: topic.to_param, topic: valid_attributes }, valid_session
        expect(response).to redirect_to(topic)
      end
    end

    context 'with invalid params' do
      it 'assigns the topic as @topic' do
        topic = Topic.create! valid_attributes
        put :update, { id: topic.to_param, topic: invalid_attributes }, valid_session
        expect(assigns(:topic)).to eq(topic)
      end

      it "re-renders the 'edit' template" do
        topic = Topic.create! valid_attributes
        put :update, { id: topic.to_param, topic: invalid_attributes }, valid_session
        expect(response).to render_template('edit')
      end
    end
  end

  describe 'DELETE #destroy' do
    it 'destroys the requested topic' do
      topic = Topic.create! valid_attributes
      expect do
        delete :destroy, { id: topic.to_param }, valid_session
      end.to change(Topic, :count).by(-1)
    end

    it 'redirects to the topics list' do
      topic = Topic.create! valid_attributes
      delete :destroy, { id: topic.to_param }, valid_session
      expect(response).to redirect_to(topics_url)
    end
  end
end
